
Redmine - Defect #6868

migrate_from_trac and trac 0.12

2010-11-11 18:10 - Félix Delval

Status: Reopened Start date: 2010-11-11

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Importers Estimated time: 0.00 hour

Target version: Candidate for next minor release   

Resolution:  Affected version:  

Description

When I migrate from my Trac 0.12 database using sqlite3. I encounter this error :

Not knowing much about ruby I have some problems finding where it comes from

www-data@myserver:~/public/ruby/redmine-1.0.3$ rake redmine:migrate_from_trac RAILS_ENV="production" --trace

(in /home/www-data/public/ruby/redmine-1.0.3)

Invoke redmine:migrate_from_trac (first_time)

Invoke environment (first_time)

Execute environment

Execute redmine:migrate_from_trac

WARNING: a new project will be added to Redmine during this process.

Are you sure you want to continue ? [y/N] y

Trac directory []: /home/www-data/public/python/trac/myproject/

Trac database adapter (sqlite, sqlite3, mysql, postgresql) [sqlite3]:

Trac database encoding [UTF-8]:

Target project identifier []: myproject

Migrating components..

Migrating milestones....

Migrating custom fields

Migrating tickets................

Migrating wiki...........................................................................................................rake aborted!

no implicit conversion to float from nil

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activesupport/lib/active_support/core_ext/ti

me/calculations.rb:277:in `minus_without_duration'

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activesupport/lib/active_support/core_ext/ti

me/calculations.rb:277:in `minus_without_coercion'

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activesupport/lib/active_support/core_ext/ti

me/calculations.rb:286:in `-'

/home/www-data/public/ruby/redmine-1.0.3/lib/tasks/migrate_from_trac.rake:79:in `fake'

/home/www-data/public/ruby/redmine-1.0.3/lib/tasks/migrate_from_trac.rake:547:in `migrate'

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activerecord/lib/active_record/associations/

association_collection.rb:369:in `method_missing'

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activerecord/lib/active_record/associations/

association_proxy.rb:215:in `method_missing'

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activerecord/lib/active_record/associations/

association_proxy.rb:215:in `each'

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activerecord/lib/active_record/associations/

association_proxy.rb:215:in `send'

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activerecord/lib/active_record/associations/

association_proxy.rb:215:in `method_missing'

/home/www-data/public/ruby/redmine-1.0.3/vendor/rails/activerecord/lib/active_record/associations/

association_collection.rb:369:in `method_missing'

/home/www-data/public/ruby/redmine-1.0.3/lib/tasks/migrate_from_trac.rake:545:in `migrate'

/home/www-data/public/ruby/redmine-1.0.3/lib/tasks/migrate_from_trac.rake:758

/usr/lib/ruby/1.8/rake.rb:636:in `call'

/usr/lib/ruby/1.8/rake.rb:636:in `execute'
/usr/lib/ruby/1.8/rake.rb:631:in `each'

/usr/lib/ruby/1.8/rake.rb:631:in `execute'

/usr/lib/ruby/1.8/rake.rb:597:in `invoke_with_call_chain'

/usr/lib/ruby/1.8/monitor.rb:242:in `synchronize'

/usr/lib/ruby/1.8/rake.rb:590:in `invoke_with_call_chain'

/usr/lib/ruby/1.8/rake.rb:583:in `invoke'

/usr/lib/ruby/1.8/rake.rb:2051:in `invoke_task'

/usr/lib/ruby/1.8/rake.rb:2029:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2029:in `each'

/usr/lib/ruby/1.8/rake.rb:2029:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2068:in `standard_exception_handling'

/usr/lib/ruby/1.8/rake.rb:2023:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2001:in `run'

/usr/lib/ruby/1.8/rake.rb:2068:in `standard_exception_handling'

/usr/lib/ruby/1.8/rake.rb:1998:in `run'

/usr/bin/rake:28

Related issues:

Related to Redmine - Patch #5764: migrate_from_trac does not support trac 0.12 New 2010-06-27

Related to Redmine - Defect #8690: User can't be displayed Needs feedback2011-06-27

Related to Redmine - Defect #10738: trac import issue New

Related to Redmine - Patch #14567: migrate_from_trac.rake does not convert ti... New

Has duplicate Redmine - Defect #14843: Error in migrate_from_trac Closed

History

#1 - 2010-11-11 19:16 - Jean-Philippe Lang

It looks like you're not using the migration script (lib/tasks/migrate_from_trac.rake) provided with 1.0.3.

Anything else to mention?

#2 - 2010-11-12 11:23 - Félix Delval

I am using the migration script from the 1.0.3 version.

The problem seems to be that function Time.fake() has problem to handle when the given input is nil.

  class ::Time

    class << self

      alias :real_now :now

      def now

        real_now - @fake_diff.to_i

      end

      def fake(time)

        @fake_diff = real_now - time

        res = yield

        @fake_diff = 0

       res

      end

    end

  end

 To solve that issue I modified this function in such way :

  class ::Time

    class << self

      alias :real_now :now

      def now

        real_now - @fake_diff.to_i

      end

      def fake(time)

        time = 0 if time.nil?

        @fake_diff = real_now - time

        res = yield

        @fake_diff = 0

       res

      end

    end

  end

 The migration works perfectly nows. I have a few other trac to migrate, I'll try this modification and if it work I'll add a patch file.
#3 - 2010-11-13 04:42 - Michał Wróbel

This is a duplicate of #5764.

#4 - 2010-11-13 14:47 - Jean-Philippe Lang

- Status changed from New to Closed

- Resolution set to Duplicate

#5 - 2011-06-27 11:24 - C. X.

- Status changed from Closed to Reopened

Why should this be a duplicate of the other issue?

The error is not even the same and the redmine versions are different!

I got the same error with trac 0.13.

The advice of Félix Delval helped me.

#6 - 2012-02-21 22:08 - Leo Shklovskii

Agreed, it's not a duplicate, it's a totally different issue. The fix that Felix did worked for me, it would be great to get it checked into trunk.

#7 - 2012-04-16 10:23 - J. R.

Still exists in redmine 1.4.0. Felix fix is working indeed.

#8 - 2012-04-16 10:42 - Etienne Massip

- Target version set to Candidate for next minor release

- Resolution deleted (Duplicate)

#9 - 2013-09-17 09:32 - Toshi MARUYAMA

- Related to Defect #14843: Error in migrate_from_trac added

#10 - 2013-10-16 14:00 - Craig Rodrigues

#14567 is a more comprehensive fix

#11 - 2013-10-19 14:11 - Toshi MARUYAMA

- Related to Patch #14567: migrate_from_trac.rake does not convert timestamps in Trac database version 23 added

#12 - 2014-10-16 13:05 - Toshi MARUYAMA

- Related to deleted (Defect #14843: Error in migrate_from_trac)

#13 - 2014-10-16 13:05 - Toshi MARUYAMA

- Has duplicate Defect #14843: Error in migrate_from_trac added

Powered by TCPDF (www.tcpdf.org)

2025-05-09 3/3

https://www.redmine.org/issues/5764
https://www.redmine.org/issues/14567
http://www.tcpdf.org

